package com.perforce.spark.view;

import javax.servlet.http.HttpServletResponse;

import org.apache.http.HttpResponse;

import spark.Request;
import spark.Response;

import com.perforce.p4java.server.IOptionsServer;
import com.perforce.spark.ErrorModel;
import com.perforce.spark.connection.ConnectionConfig;
import com.perforce.spark.connection.ConnectionSession;
import com.perforce.spark.depot.DepotFactory;
import com.perforce.spark.depot.DepotModel;
import com.perforce.spark.repository.RepoInterface;

public class ViewControl extends ErrorModel {

	public static Object view(Request request, Response response) {

		// use the 'proxy' account to view or proxy files
		String user = ConnectionConfig.getProxyUser();
		String ticket = ConnectionConfig.getProxyTicket();
		request.session().attribute(ConnectionSession.USER, user);
		request.session().attribute(ConnectionSession.TICKET, ticket);

		// get raw file from Store or Proxy
		try {
			IOptionsServer p4 = ConnectionSession.get(request, response);
			String base = request.pathInfo();
			DepotModel depot = DepotFactory.getByBase(p4, base);
			RepoInterface repo = depot.getRepo();

			if (request.queryParams().isEmpty()) {
				HttpServletResponse raw = repo.fetch(p4, request, response);
				return raw;
			} else {
				HttpResponse raw = repo.query(p4, request, response);
				return raw;
			}

		} catch (Exception e) {
			e.printStackTrace();
			response.status(404);
			return response.raw();
		}
	}
}
